'Pingppong Ballonschuss

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Leds(12) As Word
Dim X As Word
Dim Y As Word
Dim Patest As Word
Dim Zeichen As Word
Dim Hzeichen As Word
Dim Col1 As Word
Dim Col2 As Word
Dim Col3 As Word
Dim Vhelp As Word
Dim Ballricht As Byte
Dim Baelle As Byte
Dim Verz As Word
Dim Ballon As Word
Dim Schlaege As Word
Dim Punkte As Word
Dim Hpunkt1 As Word
Dim Hpunkt2 As Word
Dim Ebene As Byte


Declare Sub Standby
Declare Sub Spiel
Declare Sub Score
Declare Sub Initialisierung


Initialisierung
'*** Hauptprogrammschleife ****
Do
Spiel
Score
Standby
Loop


'*** Service-Unterprogramme ****

Sub Initialisierung
Config Portc = 15                       'PORTC als AD-Eingang
Config Portb = Output
Config Portd = 255
Config Timer2 = Timer , Prescale = 8
On Ovf2 Tim2_isr
Enable Timer2
Enable Interrupts
Start Timer2
Config Adc = Single , Prescaler = 64 , Reference = Off
Start Adc
Config Int0 = Low Level                 'Falling
On Int0 Int_isr
End Sub

Sub Spiel

Ebene = 0
Punkte = 0
Verz = 500                              'Verzgerung in ms

Level:                                  'nchster Level
Incr Ebene

Schlaege = 0
If Verz < 101 Then Verz = Verz / 2 Else Verz = Verz - 100

'Ballons initialisieren
Leds(1) = 1023
Leds(2) = 1023
Leds(3) = 1023

For Baelle = 1 To 4                     '4 Baelle pro Level

   Zeichen = 3                          'Startsequenz
   Gosub Darstellung2
   Wait 1
   Zeichen = 2
   Gosub Darstellung2
   Wait 1
   Zeichen = 1
   Gosub Darstellung2
   Wait 1
   Zeichen = 20
   Gosub Darstellung2

   Ballricht = 4                        'Ball initialisieren
   X = 4
   Y = Baelle - 1
   Gosub Pixel_set

   Do                                   'Hauptschleife

      Waitms Verz

      Dim Phelp As Word
      '2er-Paddle ansteuern
      Phelp = Getadc(7) / 120
      Phelp = 2 ^ Phelp
      Phelp = 3 * Phelp
      Leds(12) = Phelp

      'Ballons zhlen
      Ballon = Leds(1) + Leds(2)
      Ballon = Ballon + Leds(3)
      If Ballon = 0 Then
         Gosub Pixel_reset
         'Punkte fr beendeten Level berechnen
         Hpunkt1 = 50 * Ebene
         Hpunkt2 = Schlaege * Ebene
         Hpunkt1 = Hpunkt1 - Hpunkt2
         Punkte = Punkte + Hpunkt1
         Goto Level                     'zum nchsten Level
      End If

      'Ball bers Spielfeld bewegen
      Select Case Ballricht

      Case 1:
         If X < 12 Then Gosub Pixel_reset
         Decr X
         Decr Y
         If X = 1 Then Ballricht = 2
         If Y = 0 Then Ballricht = 3
         If X = 1 And Y = 0 Then Ballricht = 4
         Gosub Pixel_set

      Case 2:
         Gosub Pixel_reset
         Incr X
         Decr Y
         If X = 12 Then                 'Paddle testen
            Vhelp = 2 ^ Y
            Patest = Leds(x) And Vhelp
            If Patest = 0 Then Goto Fehler
            Incr Schlaege
            Patest = Leds(x) / Patest
            If Patest = 3 Then Ballricht = 1 Else Ballricht = 3
         End If
         If Y = 0 Then Ballricht = 4
         If X = 12 And Y = 0 Then Ballricht = 3
         Gosub Pixel_set

      Case 3:
         If X < 12 Then Gosub Pixel_reset
         Decr X
         Incr Y
         If X = 1 Then Ballricht = 4
         If Y = 9 Then Ballricht = 1
         If X = 1 And Y = 9 Then Ballricht = 2
         Gosub Pixel_set

      Case 4:
         Gosub Pixel_reset
         Incr X
         Incr Y
         If X = 12 Then                 'Paddle testen
            Vhelp = 2 ^ Y
            Patest = Leds(x) And Vhelp
            If Patest = 0 Then Goto Fehler
            Incr Schlaege
            Patest = Leds(x) / Patest
            If Patest = 3 Then Ballricht = 1 Else Ballricht = 3
         End If
         If Y = 9 Then Ballricht = 2
         If X = 12 And Y = 9 Then Ballricht = 1
         Gosub Pixel_set

      End Select

   Loop                                 'Ende der Hauptschleife
Fehler:
Next
End Sub                                 'Ende sub Spiel

Sub Score                               'Punktestand anzeigen
'Restpunkte letzter Level berechnen
Ballon = 3069 - Ballon                  'Differenz zu vollem Bild
Ballon = Ballon / 60                    'kommt auf max. 51
Hpunkt1 = Ballon * Ebene
Hpunkt2 = Schlaege * Ebene
If Hpunkt1 > Hpunkt2 Then Hpunkt1 = Hpunkt1 - Hpunkt2 Else Hpunkt1 = 0
Punkte = Punkte + Hpunkt1

Zeichen = Punkte / 100
Gosub Darstellung1

Hzeichen = Zeichen * 100
Punkte = Punkte - Hzeichen
Zeichen = Punkte / 10
Gosub Darstellung2

Hzeichen = Zeichen * 10
Zeichen = Punkte - Hzeichen
Gosub Darstellung3

Wait 10
End Sub

'Zeichen links
Darstellung1:                           '
Gosub Zeichen_z
Leds(1) = 0
Leds(2) = Col1
Leds(3) = Col2
Leds(4) = Col3
Return

'Zeichen Mitte
Darstellung2:
Gosub Zeichen_z
Leds(6) = Col1
Leds(7) = Col2
Leds(8) = Col3
Return

'Zeichen rechts
Darstellung3:
Gosub Zeichen_z
Leds(10) = Col1
Leds(11) = Col2
Leds(12) = Col3
Return

Zeichen_z:
Select Case Zeichen
Case 20:
Col1 = 0
Col2 = 0
Col3 = 0
Case 0:
Col1 = 124
Col2 = 68
Col3 = 124
Case 1:
Col1 = 0
Col2 = 8
Col3 = 124
Case 2:
Col1 = 116
Col2 = 84
Col3 = 92
Case 3:
Col1 = 84
Col2 = 84
Col3 = 124
Case 4:
Col1 = 28
Col2 = 16
Col3 = 124
Case 5:
Col1 = 92
Col2 = 84
Col3 = 116
Case 6:
Col1 = 124
Col2 = 84
Col3 = 116
Case 7:
Col1 = 4
Col2 = 4
Col3 = 124
Case 8:
Col1 = 124
Col2 = 84
Col3 = 124
Case 9:
Col1 = 92
Col2 = 84
Col3 = 124
End Select
Return


Sub Standby
Stop Timer2
Portc = 0
Portd = 0
Portb = 0
Stop Adc
Ddrd.2 = 0
Portd.2 = 1
Enable Int0
Powerdown
Ddrd.2 = 1
Portd.2 = 0
Start Adc
Start Timer2
End Sub                                 'Ende sub Standby


Pixel_set:
Vhelp = 2 ^ Y
Leds(x) = Leds(x) Or Vhelp
Return

Pixel_reset:
Vhelp = 2 ^ Y
Vhelp = Not Vhelp
Leds(x) = Leds(x) And Vhelp
Return


Int_isr:
Disable Int0
Return

Tim2_isr:
Dim Col As Byte
Dim Vy As Byte
Dim Portdout As Byte
Dim Portcout As Byte

Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1       'Data_in
Portb.3 = 1                             'Clock
Portb.3 = 0
Portb.2 = 1                             'Strobe
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15              '&B11110000
Portdout = Portdout And 240             '&B00001111
Portd = Portdout                        'Zeile 5 bis 8 ausgeben
Portc = Portcout                        'Zeile 1 bis 4 ausgeben
Portb = High(leds(vy))                  'Zeile 9 und 10 ausgeben
Return